// CkUnixCompress.h: interface for the CkUnixCompress class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CKUNIXCOMPRESS_H__6362F307_B140_4CA5_9EA7_5090F4F1EC2A__INCLUDED_)
#define AFX_CKUNIXCOMPRESS_H__6362F307_B140_4CA5_9EA7_5090F4F1EC2A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CkObject.h"

class CkString;
class CkByteData;

// CLASS: CkUnixCompress
class CkUnixCompress  : public CkObject 
{
public:
    private:
	void *m_impl;
	bool m_utf8;	// If true, all input "const char *" parameters are utf-8, otherwise they are ANSI strings.

	// Don't allow assignment or copying these objects.
	CkUnixCompress(const CkUnixCompress &) { } 
	CkUnixCompress &operator=(const CkUnixCompress &) { return *this; }

    public:
	void *getImpl(void) { return m_impl; } 

	CkUnixCompress(void *impl);

	CkUnixCompress();
	virtual ~CkUnixCompress();

	// BEGIN PUBLIC INTERFACE
	bool get_Utf8(void) const;
	void put_Utf8(bool b);

	// Error log retrieval and saving (these methods are common to all Chilkat VC++ classes.)
	bool SaveLastError(const char *filename);
        void LastErrorXml(CkString &str);
        void LastErrorHtml(CkString &str);
        void LastErrorText(CkString &str);

	bool UnlockComponent(const char *unlockCode);
	bool IsUnlocked(void) const;

	// File-to-file
	bool CompressFile(const char *inFilename, const char *outFilename);
	bool UncompressFile(const char *inFilename, const char *outFilename);

	// File-to-memory
	bool CompressFileToMem(const char *inFilename, CkByteData &db);
	bool UncompressFileToMem(const char *inFilename, CkByteData &db);

	// Memory-to-file
	bool CompressMemToFile(CkByteData &db, const char *outFilename);
	bool UncompressMemToFile(CkByteData &db, const char *outFilename);
	
	// Memory-to-memory
	bool CompressMemory(CkByteData &dbIn, CkByteData &dbOut);
	bool UncompressMemory(CkByteData &dbIn, CkByteData &dbOut);


	// END PUBLIC INTERFACE

};

#endif // !defined(AFX_CKUNIXCOMPRESS_H__6362F307_B140_4CA5_9EA7_5090F4F1EC2A__INCLUDED_)
